/*
 * File         : test1.hpj
 * Author       : Qiang Zheng
 * Created      : Wed Oct 18 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 1998/11/01 18:25:13 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

// real a(8, 8)
// !hpf$ distribute a (block, block) onto p
// !hpf$ processors p (2, 2)
//
// a(2, 6) = 23.0
//
// print *, a(2, 6)
//
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test1 {
  public static void main(String argv[]) {
    SpmdEnv spmd=new SpmdEnv(argv);

	Procs2 p = new Procs2(2,2);

	if(p.on()) {
		Range x = new BlockRange(8,p.dim(0));
		Range y = new BlockRange(8,p.dim(1)); 

		Array2ddF a = new Array2ddF(p,x,y);

		Location sx = x.location(1);
		Location sy = y.location(5);

		Array0F secx;

		if(sx.at()) {
			if(sy.at()) {
				a.dat()[a.pos(sx,sy)] = (float)23.0;
				secx = new Array0F(p.divide(sy).divide(sx),a.dat()
					,a.off() + a.str()[0].offset(sx) + a.str()[1].offset(sy));
				//Adlib.aprintf("%f\n", secx);
				//Adlib.aprintf("%f\n", a.section(s, t));
			} sy.ta();
		} sx.ta();

		secx = new Array0F(p.divide(sy).divide(sx),a.dat(),a.off()
				+ a.str()[0].offset(sx) + a.str()[1].offset(sy));
		// secx = new Array1dF(p.divide(sy),x.subrng(x.idx(sx),x.idx(sx)),a.str()[0],a.dat(),a.str()[1].offset(sy));
		Adlib.aprintf("%f\n", secx);

	} p.no();
	spmd.finalize();
  }
}
